moSetGetStationes = {};

function moSetGetStationes:setFirstStationTriggers(self, updateNewNames)	
	moStationes = {};
	--moStationesTemp = {};
	--moStationesSort = {};
	moGeneralSettings.mapStations = 0;
	moBGA = {};
	moBGA.fill = 0;	
	--moBGATrigger = {};	
	local triggerNumber = 1;
	local farmSilo = moGeneralSettings.multiFarmSilo;
	local hofSilo01 = false;
	for a, tipTrigger1 in pairs(g_currentMission.tipTriggers) do
		local siloName = getName(tipTrigger1.triggerId);
		--if siloName == "triggerPos" or siloName == "woolSellTrigger" or siloName == "woodChipsSellTrigger" or siloName == "windrowTrigger" or siloName == "tipTrigger1" then --or siloName == "tipTrigger" then
				local tipTrigger = tipTrigger1;				
				local stationName = tipTrigger.stationName;				
				local isAreaTrigger = Utils.getNoNil(tipTrigger.isAreaTrigger, false);
				local isFarmTrigger = Utils.getNoNil(tipTrigger.isFarmTrigger, false);							
				local id = tipTrigger.triggerId;		
				if stationName ~= nil and (tipTrigger.appearsOnPDA) then -- or string.find(string.lower(stationName), "placeableheatingplant")) then					
					if tipTrigger.priceMultipliers ~= nil and tipTrigger.acceptedFillTypes ~= nil then				
						local textName = stationName;
						local replaceName = false;				
						if g_i18n:hasText(stationName) then
							textName = g_i18n:getText(stationName);
							replaceName = true;
						end;				
						local checkLeerName = stationName;
						if string.find(stationName, " ") then
							checkLeerName = string.gsub(stationName, " ", "_");
						end;
						local languageStationName = moLanguageXml:getTxt("station_".. string.lower(checkLeerName));
						if languageStationName ~= "L Error" and languageStationName ~= "L Missing" then
							if tipTrigger.mapHotspot.fullViewName ~= nil then tipTrigger.mapHotspot.fullViewName = languageStationName;end;
							textName = languageStationName;
							replaceName = true;
						end;
						local foundTrain = false;
						--ls17
						if tipTrigger.isTrainOnly ~= nil and tipTrigger.isTrainOnly then
							foundTrain = true;moGeneralSettings.trainStationFound = true;
						end;
						--if tipTrigger.updateEventListeners ~= nil then
						--if stationName == "StationFreightYard" then									
						--	for key, value in pairs(tipTrigger.updateEventListeners) do
						--		if foundTrain then break;end;						
						--		for key1, value1 in pairs(value) do
						--			if key1 == "train" then	foundTrain = true;moGeneralSettings.trainStationFound = true;break;end;							
						--		end;
						--	end;
						--end;
						--if foundTrain then textName = textName.. "(+".. tostring(moLanguageXml:getTxt("train", nil, "Train")).. ")";end;
						local lengthName = string.len(textName);				
						if lengthName > moGeneralSettings.lengthStationName then moGeneralSettings.lengthStationName = lengthName;end;
						--moGeneralSettings.lengthStation = moGeneralSettings.lengthStation+lengthName+3;
						moGeneralSettings.mapStations = moGeneralSettings.mapStations+1;
						moStationes[stationName] = {};
						--if stationName == "BGA_Station_name" then
						--	moBGATrigger[bga] = {};					
						--	moBGATrigger[bga].bgaTrigger = tipTrigger;					
						--	bga = bga+1;
						--end;
						--if stationName ~= "BGA_Station_name" and string.find(string.lower(stationName), "bga") then
						--	moBGATrigger[bga] = {};					
						--	moBGATrigger[bga].bgaTrigger = tipTrigger;					
						--	bga = bga+1;
						--end;
						--table.insert(moStationesSort, stationName);
						local x,y,z = getWorldTranslation(tipTrigger.rootNode);				
						moStationes[stationName].x = x;
						moStationes[stationName].y = y;
						moStationes[stationName].z = z;				
						moStationes[stationName].station = stationName;
						moStationes[stationName].stationName = textName;
						moStationes[stationName].stationNameReplace = replaceName;
						moStationes[stationName].stationNameLength = lengthName;
						moStationes[stationName].acceptedFillTypes = tipTrigger.acceptedFillTypes;
						moStationes[stationName].priceMultipliers = tipTrigger.priceMultipliers;
						moStationes[stationName].greatDemand = false;
						moStationes[stationName].greatDemandFruit = "";
						moStationes[stationName].greatDemandMultiplier = 1;
						moStationes[stationName].greatDemandDuration = 0;
						moStationes[stationName].firstLetter = 0;
						moStationes[stationName].isTrain = foundTrain;
						moStationes[stationName].close = false;
						moStationes[stationName].insolvenz = false;
						moStationes[stationName].shares = {};
						moStationes[stationName].tipTrigger = tipTrigger;
						moStationes[stationName].palSellTrigger2 = nil;
						moStationes[stationName].checkPalSellTrigger2 = false;
						--print("station name...".. tostring(textName))
					end;		
				elseif not hofSilo01 then --unLoad	
					if isFarmTrigger and isAreaTrigger and siloName ~= nil and siloName == "grainStationTrigger" then
						if tipTrigger.acceptedFillTypes ~= nil then																		
							local fillTypes = getUserAttribute(tipTrigger.triggerId, "fillTypes");									
							if fillTypes == nil then
								fillTypes = getUserAttribute(tipTrigger.triggerId, "fruitTypes");
							end;
							if string.find(fillTypes, "wheat ") ~= nil then							
								if string.len(moGeneralSettings.multiFarmSiloUnLoad) > 1 then
									moGeneralSettings.multiFarmSiloUnLoad = moGeneralSettings.multiFarmSiloUnLoad.. " ";
								else
									moGeneralSettings.multiFarmSiloUnLoad = fillTypes.. " ";
								end;
								local fillTypesSplit = Utils.splitString(" ", moGeneralSettings.multiFarmSiloUnLoad);						
								for k,v in pairs(fillTypesSplit) do
									local desc = FillUtil.fillTypeNameToDesc[v];
									if desc ~= nil and tipTrigger.acceptedFillTypes[desc.index] == nil then
										moFillTypes[desc.index].siloUnLoad[farmSilo] = true;
										if not MultiOverlayV2.isMp then
											tipTrigger.acceptedFillTypes[desc.index] = true;
										end;
									elseif desc ~= nil then
										moFillTypes[desc.index].siloUnLoad[farmSilo] = true;
									end;						
								end;							
								hofSilo01 = true;
								if moMapTrigger == nil then moMapTrigger = {};end;
								moMapTrigger["hofSiloUnLoad"] = tipTrigger;
							end;						
						end;					
					end;
				end;
			
		--end;
	end;
	--function compare(a,b)
	--	return a[1] < b[1];
	--end
	--table.sort(moStationesSort, compare);	
	--function getKeysSortedByValue(tbl, sortFunction)
	--	local keys = {};
	--	for key in pairs(tbl) do
	--		table.insert(keys, key);
	--	end;
	--	table.sort(keys, function(a, b)
	--		return sortFunction(tbl[a], tbl[b])
	--	end)
	--	return keys;
	--end
	--local sortedKeys = getKeysSortedByValue(moStationesSort, function(a, b) return a < b end);	
	--for _, key in ipairs(sortedKeys) do
	--	local stationName = moStationesSort[key];
		--moStationes[stationName] = {};
	--	table.insert(moStationes[stationName], moStationesTemp[stationName]);
	--	print(key, moStationesSort[key])
	--end;	
	--table.remove(moStationesTemp);
	--table.remove(moStationesSort);	
end;

function moSetGetStationes:setStationUpdate(self, all, train)	
	moBGA.fill = 0;	
	moGeneralSettings.bestPriceFoundObjects = 0;
	moGeneralSettings.bestPriceFoundFruitNames = "";
	if all then		
		for a=1, FillUtil.NUM_FILLTYPES do			
			local desc = FillUtil.fillTypeIndexToDesc[a];
			if desc.name ~= "snow" and desc.name ~= "lightStraw" and desc.name ~= "darkStraw" and desc.name ~= "maizeStraw" and desc.name ~= "sunflowerStraw" and not string.find(desc.name, "_haulm") then		
				if moFillTypes[desc.index] ~= nil then ----Anpassung an Mods made by HappyLooser----
					moFillTypes[desc.index].bestPrice = 0;
					moFillTypes[desc.index].bestPriceStation = "";
					moFillTypes[desc.index].bestPriceStationDescName = nil;
					moFillTypes[desc.index].greatDemandStation = nil;
					moFillTypes[desc.index].greatDemandStationDescName = nil;
					moFillTypes[desc.index].greatDemandMultiplier = 1;					
					if desc.name ~= "silage" then
						moFillTypes[desc.index].pricePerLiter = Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0), 0); --Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].pricePerLiter,0);
						moFillTypes[desc.index].previousHourPrice = Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0), 0);					
						moFillTypes[desc.index].startPricePerLiter = Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0), 0); --Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].startPricePerLiter,0);
					else
						moFillTypes[desc.index].pricePerLiter = Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].pricePerLiter,0); --Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0)); --Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].pricePerLiter,0);
						moFillTypes[desc.index].previousHourPrice = moFillTypes[desc.index].pricePerLiter; --Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0));					
						moFillTypes[desc.index].startPricePerLiter = moFillTypes[desc.index].pricePerLiter; --Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0)); --Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].startPricePerLiter,0);
					end;
					moFillTypes[desc.index].moneyTotal = 0;
					moFillTypes[desc.index].stationPriceMulti = {};
					moFillTypes[desc.index].stationPriceMultiChange = {};
					moFillTypes[desc.index].palFruit = false;					
					--if desc.name ~= nil and moGeneralSettings.newFillPlanes and not moFillTypes[desc.index].checkNewFillPlane then
					--	local newFillPlaneI3DFile = MultiOverlayV2.fillPlanesDir.. "/".. desc.name.. "/fillPlane.i3d";
						--print("descName...".. tostring(desc.name))
					--	if fileExists(newFillPlaneI3DFile) then 
							--print("set new fillPlanes...".. tostring(desc.name))
					--		moGuiExtras:loadNewFillPlane(self, newFillPlaneI3DFile, desc.name);
					--		moFillTypes[desc.index].checkNewFillPlane = true;
					--	end;				
					--end;				
				end;
				----bestPrice Total----
				if FillUtil.fillTypeIndexToDesc[a].partOfEconomy ~= nil and FillUtil.fillTypeIndexToDesc[a].partOfEconomy and moFillTypes[desc.index] ~= nil or desc.name == "silage" then				
					local emptyFruit = moSetGetAmount:getNoFoundSiloAmount(a);					
				end;
				----bestPrice Total----				
			end;
		end;		
	end;
	for a, tipTrigger1 in pairs(g_currentMission.tipTriggers) do
		local siloName = getName(tipTrigger1.triggerId);
		--if siloName == "triggerPos" or siloName == "woolSellTrigger" or siloName == "woodChipsSellTrigger" or siloName == "windrowTrigger" or siloName == "tipTrigger1" then --or siloName == "tipTrigger" then
				local tipTrigger = tipTrigger1;
				local stationName = tipTrigger.stationName;		
				--print("tipTrigger...".. tostring(tipTrigger.appearsOnPDA))
				local triggerValues = tipTrigger;
				--print("triggerValues...".. tostring(triggerValues.appearsOnPDA))
				if stationName ~= nil and moStationes[stationName] ~= nil and (tipTrigger.appearsOnPDA) then -- or string.find(string.lower(stationName), "placeableheatingplant")) then			
					if tipTrigger.priceMultipliers ~= nil and tipTrigger.acceptedFillTypes ~= nil then				
						local fillTypes = "";
						local palFillTypes = "";
						if all and moMapObjects ~= nil and #moMapObjects.palSellTrigger > 0 and not moStationes[stationName].checkPalSellTrigger2 then					
							function checkPalSellTrigger(mapPalSellTrigger, mx, my, mz)
								local px = moStationes[stationName].x;
								local py = moStationes[stationName].y;
								local pz = moStationes[stationName].z;
								local distance = Utils.vector3Length(px-mx, py-my, pz-mz);
								local sellStationName = mapPalSellTrigger.stationName;
								if mx == px and mz == pz or distance <= 15 then --and mz == pz then							
									moStationes[stationName].palSellTrigger2 = mapPalSellTrigger;
									--print("found station sellTrigger...".. tostring(stationName))
									return true;
								elseif sellStationName ~= nil and sellStationName == stationName then							
									moStationes[stationName].palSellTrigger2 = mapPalSellTrigger;
									--print("found station sellTrigger...".. tostring(stationName))
									return true;
								end;
								--print("not found station sellTrigger...".. tostring(stationName))
								--print("x...".. tostring(px))
								--print("y...".. tostring(py))
								--print("z...".. tostring(pz))
								return false;						
							end;
							for palSellTrigger2=1, #moMapObjects.palSellTrigger do
								if moMapObjects.palSellTrigger[palSellTrigger2] ~= nil and moMapObjects.palSellTrigger[palSellTrigger2].x ~= nil and moMapObjects.palSellTrigger[palSellTrigger2].y ~= nil and moMapObjects.palSellTrigger[palSellTrigger2].z ~= nil then
									local mx = moMapObjects.palSellTrigger[palSellTrigger2].x;
									local my = moMapObjects.palSellTrigger[palSellTrigger2].y;
									local mz = moMapObjects.palSellTrigger[palSellTrigger2].z;							
									if checkPalSellTrigger(moMapObjects.palSellTrigger[palSellTrigger2], mx, my, mz) then moMapObjects.palSellTrigger[palSellTrigger2].foundMasterStation = true;break;end;
								end;
							end;
							--moStationes[stationName].checkPalSellTrigger2 = true;
						end;
						if not moStationes[stationName].stationNameReplace then
							if g_i18n:hasText(stationName) then
								local textName = g_i18n:getText(stationName);						
								local lengthName = string.len(textName);				
								if lengthName > moGeneralSettings.lengthStationName then moGeneralSettings.lengthStationName = lengthName;end;
							end;
							if g_currentMission.moh_i18n ~= nil then
								local textName = g_currentMission.moh_i18n:getText(stationName);						
								if not string.find(textName, "Missing") then
									local lengthName = string.len(textName);				
									if lengthName > moGeneralSettings.lengthStationName then moGeneralSettings.lengthStationName = lengthName;end;
									if tipTrigger.mapHotspot.fullViewName ~= nil then tipTrigger.mapHotspot.fullViewName = textName;end;
									moStationes[stationName].stationName = textName;							
								end;						
							end;
							moStationes[stationName].stationNameReplace = true;
						end;				
						if all then
						----Anpassung an Mods made by HappyLooser----
							for k,v in pairs(tipTrigger.acceptedFillTypes) do
								local desc = FillUtil.fillTypeIntToName[k];						
								local descIndex = FillUtil.fillTypeIndexToDesc[desc];
								if desc ~= nil and tipTrigger.acceptedFillTypes[k] then
									if string.len(fillTypes) == 0 then
										fillTypes = desc;
									else
										fillTypes = fillTypes.. " ".. desc;
									end;							
									--if descName ~= nil and moFillTypes[descName.index] ~= nil then
										--print("eintragen ".. stationName)
										--moFillTypes[desc].stationPriceMulti[stationName.. "PriceMulti"] = tipTrigger.priceMultipliers[desc];
									--end;
								end;
							end;
							if moStationes[stationName].palSellTrigger2 ~= nil and moStationes[stationName].palSellTrigger2.fillTypes ~= nil and moStationes[stationName].palSellTrigger2.priceMultipliers ~= nil then
								for k,v in pairs(moStationes[stationName].palSellTrigger2.fillTypes) do
									local desc = FillUtil.fillTypeIntToName[k];						
									--local descIndex = FillUtil.fillTypeIndexToDesc[desc];							
									if desc ~= nil and moStationes[stationName].palSellTrigger2.fillTypes[k] then
										local descIndex = FillUtil.fillTypeNameToDesc[desc];
										if string.len(fillTypes) == 0 then
											fillTypes = desc;
										else
											fillTypes = fillTypes.. " ".. desc;
										end;
										if descIndex ~= nil and moPalFillTypes[descIndex.index] == nil then moPalFillTypes[descIndex.index] = {};end;
										--if string.len(palFillTypes) == 0 then
										--	palFillTypes = desc.. ",";
										--else
										--	palFillTypes = palFillTypes.. desc.. ",";
										--end;
										triggerValues.priceMultipliers[descIndex.index] = tonumber(moStationes[stationName].palSellTrigger2.priceMultipliers[k]);
									end;
								end;
							end;
							moStationes[stationName].acceptedFillTypes = fillTypes;
						else
							fillTypes = moStationes[stationName].acceptedFillTypes;
						end;				
						----Anpassung an Mods made by HappyLooser----				
						local types = Utils.splitString(" ", fillTypes);
						local greatDemand = false;				
						for i, nameFruit in pairs(types) do
							--local descPal = Utils.getNoNil(moPalFillTypes[descIndex.index]); --string.find(palFillTypes, nameFruit.. ",");
							local desc = FillUtil.fillTypeNameToDesc[nameFruit];							
							if desc.name ~= "snow" and desc.name ~= "lightStraw" and desc.name ~= "darkStraw" and desc.name ~= "maizeStraw" and desc.name ~= "sunflowerStraw" and not string.find(desc.name, "_haulm") then							
								---best price
								local trainPriceMulti = 1;
								if moGeneralSettings.isTrainPrice and moStationes[stationName].isTrain then trainPriceMulti = moGeneralSettings.trainPriceMulti;end;
								--ls17
								--local priceMulti = Utils.getNoNil(triggerValues.priceMultipliers[desc.index], 0)*trainPriceMulti;
								local priceMulti = (moSetGetStationes:getFillTypePrice(triggerValues, stationName, desc.index)*1000*trainPriceMulti); --g_i18n:formatNumber
								local priceMultiError = false;
								--if priceMulti == nil then priceMulti = Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0)) * Utils.getNoNil(triggerValues:getPriceMultiplier(desc.index), 0)*1000*trainPriceMulti;priceMultiError=true;end;
								local checkOldPriceMulti = (moFillTypes[desc.index].bestPrice); --g_i18n:formatNumber
								--print("desc.name.. ".. tostring(desc.name).. " -priceMulti... ".. tostring(priceMulti).. " -checkOldPriceMulti.. ".. tostring(checkOldPriceMulti))
								--if desc.name == "maize" then print("priceMulti..".. tostring(priceMulti).. " -oldPriceMulti..".. tostring(checkOldPriceMulti).. " -fruit..".. tostring(desc.name).. " -station..".. tostring(moStationes[stationName].stationName));end;
								if priceMulti > checkOldPriceMulti or (moFillTypes[desc.index].bestPriceStation == moStationes[stationName].stationName) then
									--if desc.name == "maize" then print("newBestPrice..".. tostring(desc.name).. " -station..".. tostring(moStationes[stationName].stationName));end;
									--ls17
									--moFillTypes[desc.index].bestPrice = Utils.getNoNil(triggerValues.priceMultipliers[desc.index], 0)*trainPriceMulti; --TipTrigger:getPriceMultiplier(fillType)									
									moFillTypes[desc.index].bestPrice = moSetGetStationes:getFillTypePrice(triggerValues, stationName, desc.index)*1000*trainPriceMulti;
									moFillTypes[desc.index].bestPriceStation = moStationes[stationName].stationName;
									moFillTypes[desc.index].bestPriceStationDescName = stationName;
									if not string.find(moGeneralSettings.bestPriceFoundFruitNames, desc.name.. ",") then
										moGeneralSettings.bestPriceFoundFruitNames = moGeneralSettings.bestPriceFoundFruitNames.. tostring(desc.name).. ",";
										moGeneralSettings.bestPriceFoundObjects = moGeneralSettings.bestPriceFoundObjects+1;
									end;							
									moFillTypes[desc.index].x = moStationes[stationName].x;
									moFillTypes[desc.index].z = moStationes[stationName].z;
								else
									if not string.find(moGeneralSettings.bestPriceFoundFruitNames, desc.name.. ",") then
										moGeneralSettings.bestPriceFoundFruitNames = moGeneralSettings.bestPriceFoundFruitNames.. tostring(desc.name).. ",";
										moGeneralSettings.bestPriceFoundObjects = moGeneralSettings.bestPriceFoundObjects+1;
									end;							
								end;						
								---best price
								moFillTypes[desc.index].palFruit = Utils.getNoNil(moPalFillTypes[desc.index], false);
								--ls17
								--moFillTypes[desc.index].stationPriceMulti[stationName.. " PriceMulti"] = Utils.getNoNil(triggerValues.priceMultipliers[desc.index], 0)*trainPriceMulti;
								--moFillTypes[desc.index].stationPriceMultiChange[stationName.. " PriceMulti"] = Utils.getNoNil(triggerValues.priceMultipliers[desc.index], 0);
								--if desc.name == "maize" then print("stationPriceMulti..".. tostring(desc.name).. " -price..".. tostring(Utils.getNoNil(moStationes[stationName].tipTrigger:getEffectiveFillTypePrice(desc.index), 0)*1000*trainPriceMulti));end;
								moFillTypes[desc.index].stationPriceMulti[stationName.. " PriceMulti"] = moSetGetStationes:getFillTypePrice(triggerValues, stationName, desc.index)*1000*trainPriceMulti;
								moFillTypes[desc.index].stationPriceMultiChange[stationName.. " PriceMulti"] = Utils.getNoNil(triggerValues:getPriceMultiplier(desc.index), 0);
								if g_currentMission.economyManager:getPricePerLiter(desc.index, 0) ~= nil then
									moFillTypes[desc.index].pricePerLiter = Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0), 0); --Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].pricePerLiter, 0);						
									moFillTypes[desc.index].previousHourPrice = Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0), 0); --Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].previousHourPrice,0);
								else
									moFillTypes[desc.index].pricePerLiter = Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].pricePerLiter, 0);						
									moFillTypes[desc.index].previousHourPrice = Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].previousHourPrice,0);
								end;
								if triggerValues.pricingDynamics ~= nil and triggerValues.pricingDynamics[desc.index] ~= nil and Utils.getNoNil(triggerValues.pricingDynamics[desc.index]:getBaseCurveTrend(), "unknown") == PricingDynamics.TREND_FALLING then --tonumber(moFillTypes[desc.index].pricePerLiter) < tonumber(moFillTypes[desc.index].previousHourPrice) then
									moFillTypes[desc.index].stateHourPrice = 2; --down							
								elseif triggerValues.pricingDynamics ~= nil and triggerValues.pricingDynamics[desc.index] ~= nil and Utils.getNoNil(triggerValues.pricingDynamics[desc.index]:getBaseCurveTrend(), "unknown") == PricingDynamics.TREND_CLIMBING then --tonumber(moFillTypes[desc.index].pricePerLiter) > tonumber(moFillTypes[desc.index].previousHourPrice) then
									moFillTypes[desc.index].stateHourPrice = 1; --up							
								else
									moFillTypes[desc.index].stateHourPrice = 0; --equal							
								end;
								moFillTypes[desc.index].stateHourPrice = 0; --equal	LS17 disable
								if g_currentMission.economyManager:getPricePerLiter(desc.index, 0) ~= nil then
									moFillTypes[desc.index].startPricePerLiter = Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0), 0); --Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].startPricePerLiter,0);						
								else
									moFillTypes[desc.index].startPricePerLiter = Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].startPricePerLiter,0);	
								end;
								if g_currentMission.economyManager ~= nil then
									local demand = g_currentMission.economyManager:getCurrentGreatDemand(tipTrigger.stationName, desc.index);						
									local greatDemandMultiplier = 1;
									if demand ~= nil and demand.isRunning then
										greatDemand = true;
										if not moStationes[stationName].greatDemand then
											moGeneralSettings.foundGreatDemand = moGeneralSettings.foundGreatDemand+1;
										end;
										moStationes[stationName].greatDemand = true;
										moFillTypes[desc.index].greatDemandStation = moStationes[stationName].stationName;
										moFillTypes[desc.index].greatDemandStationDescName = stationName;
										moFillTypes[desc.index].x = moStationes[stationName].x;
										moFillTypes[desc.index].z = moStationes[stationName].z;
										greatDemandMultiplier = demand.demandMultiplier;
										moFillTypes[desc.index].greatDemandMultiplier = demand.demandMultiplier;
										moStationes[stationName].greatDemandDuration = demand.demandDuration; ---active test, DrawWarnings														
										moStationes[stationName].greatDemandMultiplier = demand.demandMultiplier;
										local demandFruits = moStationes[stationName].greatDemandFruit;
										if string.find(demandFruits, nameFruit.. " ") == nil then
											moStationes[stationName].greatDemandFruit = moStationes[stationName].greatDemandFruit.. nameFruit.. " ";
										end;						
									end;
								end;						
							end;
						end;
						for k,v in pairs(moFillTypes) do
							if moFillTypes[k].stationPriceMultiChange[stationName.. " PriceMulti"] == nil then
								moFillTypes[k].stationPriceMultiChange[stationName.. " PriceMulti"] = 0.00;
							end;
						end;
						if not greatDemand then
							if moStationes[stationName].greatDemand then
								moGeneralSettings.foundGreatDemand = moGeneralSettings.foundGreatDemand-1;
							end;
							moStationes[stationName].greatDemand = false;					
							moStationes[stationName].greatDemandMultiplier = 1;
							moStationes[stationName].greatDemandDuration = 0;
							moStationes[stationName].greatDemandFruit = "";
						end;
						moStationes[stationName].tipTrigger = tipTrigger;
					end;
				else
					if tipTrigger.bunkerSilo ~= nil and tipTrigger.bunkerSilo.state == 2 then
						moBGA.fill = moBGA.fill+math.ceil(tipTrigger.bunkerSilo.fillLevel);								
					end;
					if stationName ~= nil and moStationes[stationName] ~= nil and not tipTrigger.appearsOnPDA then
						moStationes[stationName].close = true; ----Anpassung an Mods made by HappyLooser----
					end;			
				end;
			
		--end;
	end;	
	if moMapObjects ~= nil and #moMapObjects.palSellTrigger > 0 then
		local shops = 1;
		for palSellTrigger2=1, #moMapObjects.palSellTrigger do
			if moMapObjects.palSellTrigger[palSellTrigger2] ~= nil and not moMapObjects.palSellTrigger[palSellTrigger2].foundMasterStation and moMapObjects.palSellTrigger[palSellTrigger2].fillTypes ~= nil and moMapObjects.palSellTrigger[palSellTrigger2].priceMultipliers ~= nil then
				local stationName = moMapObjects.palSellTrigger[palSellTrigger2].stationName;
				if stationName == nil then stationName = "Pal ".. tostring(moLanguageXml:getTxt("station")).. " ".. tostring(shops);shops = shops+1;end;
				local lengthName = string.len(stationName);				
				if lengthName > moGeneralSettings.lengthStationName then moGeneralSettings.lengthStationName = lengthName;end;
				local fillTypes = "";				
				if moStationes[stationName] == nil then 
					moStationes[stationName] = {};
					moGeneralSettings.mapStations = moGeneralSettings.mapStations+1;
					moStationes[stationName].x = Utils.getNoNil(moMapObjects.palSellTrigger[palSellTrigger2].x, 0);
					moStationes[stationName].y = Utils.getNoNil(moMapObjects.palSellTrigger[palSellTrigger2].y, 0);
					moStationes[stationName].z = Utils.getNoNil(moMapObjects.palSellTrigger[palSellTrigger2].z, 0);				
					moStationes[stationName].station = stationName;
					moStationes[stationName].stationName = stationName;
					moStationes[stationName].stationNameReplace = false;
					moStationes[stationName].stationNameLength = lengthName;					
					moStationes[stationName].greatDemand = false;
					moStationes[stationName].greatDemandFruit = "";
					moStationes[stationName].greatDemandMultiplier = 1;
					moStationes[stationName].greatDemandDuration = 0;
					moStationes[stationName].firstLetter = 0;
					moStationes[stationName].palTrigger = true;
					moStationes[stationName].isTrain = false;
					moStationes[stationName].close = false;
					moStationes[stationName].insolvenz = false;
					moStationes[stationName].shares = {};
				end;
				for k,v in pairs(moMapObjects.palSellTrigger[palSellTrigger2].fillTypes) do
					local desc = FillUtil.fillTypeIntToName[k];						
					--local descIndex = FillUtil.fillTypeIndexToDesc[desc];							
					if desc ~= nil and moMapObjects.palSellTrigger[palSellTrigger2].fillTypes[k] then
						local descIndex = FillUtil.fillTypeNameToDesc[desc];
						if string.len(fillTypes) == 0 then
							fillTypes = desc;
						else
							fillTypes = fillTypes.. " ".. desc;
						end;
						if descIndex ~= nil and moPalFillTypes[descIndex.index] == nil then moPalFillTypes[descIndex.index] = {};end;
					end;
				end;
				local triggerValues = moMapObjects.palSellTrigger[palSellTrigger2];
				local types = Utils.splitString(" ", fillTypes);
				local greatDemand = false;				
				for i, nameFruit in pairs(types) do
					local desc = FillUtil.fillTypeNameToDesc[nameFruit];
					if desc ~= nil then
						local trainPriceMulti = 1;
						if moGeneralSettings.isTrainPrice and moStationes[stationName].isTrain then trainPriceMulti = moGeneralSettings.trainPriceMulti;end;
						--ls17
						--local priceMulti = Utils.getNoNil(triggerValues.priceMultipliers[desc.index], 0)*trainPriceMulti;
						local priceMulti = moSetGetStationes:getFillTypePrice(triggerValues, stationName, desc.index)*1000*trainPriceMulti;
						if priceMulti == nil and g_currentMission.economyManager:getPricePerLiter(desc.index, 0) ~= nil then priceMulti = Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0), 0) * Utils.getNoNil(triggerValues:getPriceMultiplier(desc.index), 0)*1000*trainPriceMulti;end;
						if priceMulti == nil and g_currentMission.economyManager:getPricePerLiter(desc.index, 0) == nil then priceMulti = Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].pricePerLiter, 0) * Utils.getNoNil(triggerValues:getPriceMultiplier(desc.index), 0)*1000*trainPriceMulti;end;
						local checkOldPriceMulti = moFillTypes[desc.index].bestPrice;
						if priceMulti > checkOldPriceMulti or moFillTypes[desc.index].bestPriceStation == moStationes[stationName].stationName then
							--ls17
							--moFillTypes[desc.index].bestPrice = Utils.getNoNil(triggerValues.priceMultipliers[desc.index], 0)*trainPriceMulti;
							moFillTypes[desc.index].bestPrice = moSetGetStationes:getFillTypePrice(triggerValues, stationName, desc.index)*1000*trainPriceMulti;
							moFillTypes[desc.index].bestPriceStation = moStationes[stationName].stationName;
							if not string.find(moGeneralSettings.bestPriceFoundFruitNames, desc.name.. ",") then
								moGeneralSettings.bestPriceFoundFruitNames = moGeneralSettings.bestPriceFoundFruitNames.. tostring(desc.name).. ",";
								moGeneralSettings.bestPriceFoundObjects = moGeneralSettings.bestPriceFoundObjects+1;
							end;							
							moFillTypes[desc.index].x = moStationes[stationName].x;
							moFillTypes[desc.index].z = moStationes[stationName].z;
						else
							if not string.find(moGeneralSettings.bestPriceFoundFruitNames, desc.name.. ",") then
								moGeneralSettings.bestPriceFoundFruitNames = moGeneralSettings.bestPriceFoundFruitNames.. tostring(desc.name).. ",";
								moGeneralSettings.bestPriceFoundObjects = moGeneralSettings.bestPriceFoundObjects+1;
							end;							
						end;						
						---best price
						moFillTypes[desc.index].palFruit = true;
						--ls17
						--moFillTypes[desc.index].stationPriceMulti[stationName.. " PriceMulti"] = Utils.getNoNil(triggerValues.priceMultipliers[desc.index], 0)*trainPriceMulti;
						--moFillTypes[desc.index].stationPriceMultiChange[stationName.. " PriceMulti"] = Utils.getNoNil(triggerValues.priceMultipliers[desc.index], 0);
						moFillTypes[desc.index].stationPriceMulti[stationName.. " PriceMulti"] = moSetGetStationes:getFillTypePrice(triggerValues, stationName, desc.index)*1000*trainPriceMulti;
						moFillTypes[desc.index].stationPriceMultiChange[stationName.. " PriceMulti"] = Utils.getNoNil(triggerValues.priceMultipliers(desc.index), 0);
						if g_currentMission.economyManager:getPricePerLiter(desc.index, 0) ~= nil then
							moFillTypes[desc.index].pricePerLiter = Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0), 0);						
							moFillTypes[desc.index].previousHourPrice = Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index), 0);
						else
							moFillTypes[desc.index].pricePerLiter = Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].pricePerLiter, 0);						
							moFillTypes[desc.index].previousHourPrice = Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].previousHourPrice,0);
						end;
						--if triggerValues.pricingDynamics ~= nil and triggerValues.pricingDynamics[desc.index] ~= nil and Utils.getNoNil(triggerValues.pricingDynamics[desc.index]:getBaseCurveTrend(), "unknown") == PricingDynamics.TREND_FALLING then --tonumber(moFillTypes[desc.index].pricePerLiter) < tonumber(moFillTypes[desc.index].previousHourPrice) then
						--	moFillTypes[desc.index].stateHourPrice = 2; --down							
						--elseif triggerValues.pricingDynamics ~= nil and triggerValues.pricingDynamics[desc.index] ~= nil and Utils.getNoNil(triggerValues.pricingDynamics[desc.index]:getBaseCurveTrend(), "unknown") == PricingDynamics.TREND_CLIMBING then --tonumber(moFillTypes[desc.index].pricePerLiter) > tonumber(moFillTypes[desc.index].previousHourPrice) then
						--	moFillTypes[desc.index].stateHourPrice = 1; --up							
						--else
						--	moFillTypes[desc.index].stateHourPrice = 0; --equal							
						--end;
						moFillTypes[desc.index].stateHourPrice = 0; --equal	LS17 disable
						if g_currentMission.economyManager:getPricePerLiter(desc.index, 0) ~= nil then
							moFillTypes[desc.index].startPricePerLiter = Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0), 0);
						else
							moFillTypes[desc.index].startPricePerLiter = Utils.getNoNil(FillUtil.fillTypeIndexToDesc[desc.index].startPricePerLiter,0);
						end;
					end;
				end;
			end;
		end;
	end;
end;

function moSetGetStationes:getFillTypePrice(tipTrigger, stationName, fillType)
	local fillTypePrice = 1;	
	if tipTrigger ~= nil and fillType ~= nil and fillType ~= 0 then
		if Utils.getNoNil(tipTrigger.isServer, false) then
			fillTypePrice = ((Utils.getNoNil(tipTrigger.fillTypePrices[fillType], 0) + Utils.getNoNil(tipTrigger.fillTypePriceRandomDelta[fillType], 1)) * Utils.getNoNil(tipTrigger.priceMultipliers[fillType], 1));
		else
			fillTypePrice = Utils.getNoNil(tipTrigger.fillTypePrices[fillType], 1);
		end;
	end;
	--fillTypePrice = Utils.getNoNil(tipTrigger.getEffectiveFillTypePrice(fillType), 1);
	--fillTypePrice = Utils.getNoNil(moStationes[stationName].tipTrigger:getEffectiveFillTypePrice(fillType), 0)
	return fillTypePrice
end;

function moSetGetStationes:setStationsMaxProSwitch(self)	
	local station = moGeneralSettings.mapStations/moSetGetGui.page[1].maxStationsProSwitch;
	local maxSwitch = moSetGetGui:round(station+0.5);	
	if maxSwitch < 1 then maxSwitch = 1;end;
	moSetGetGui.page[1].maxStationsSwitch = maxSwitch;	
	if moSetGetGui.page[1].stationsSwitch > maxSwitch then moSetGetGui.page[1].stationsSwitch = 1;end;
end;

function moSetGetStationes:setFirstEndStations(self)	
	if moSetGetGui.page[1].stationsSwitch == 1 then moSetGetGui.page[1].firstStation = 1;moSetGetGui.page[1].endStation = moSetGetGui.page[1].maxStationsProSwitch;end;
	if moSetGetGui.page[1].stationsSwitch > 1 then moSetGetGui.page[1].firstStation = (moSetGetGui.page[1].stationsSwitch-1)*moSetGetGui.page[1].maxStationsProSwitch+(1);moSetGetGui.page[1].endStation = moSetGetGui.page[1].stationsSwitch*moSetGetGui.page[1].maxStationsProSwitch;end;
	if moSetGetGui.page[1].endStation > moGeneralSettings.mapStations then moSetGetGui.page[1].endStation = moGeneralSettings.mapStations;end;
end;